=== debian/changelog ===
ros-indigo-log4cpp (2.8.3-0trusty) trusty; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Orocos Developers <orocos-dev@lists.mech.kuleuven.be>  Thu, 11 Aug 2016 12:06:15 -0000
